// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <iostream>
#include <gtkmm.h>
#include <glibmm.h>
#include <string>

//#include "logik.hpp"
#include "gui.hpp"
#include "shareddata.hpp"
#include "helper.h"

#include <libintl.h>
#include "config.h"

int main(int argc, char **argv) {
  if(!Glib::thread_supported()) Glib::thread_init();

  Glib::OptionGroup maingroup("","","");

  bindtextdomain(GETTEXT_PACKAGE, LOCALEDIR);
  bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
  textdomain(GETTEXT_PACKAGE);

  int numberof_ai = 0;

  Glib::OptionEntry entry_ai;
  entry_ai.set_description(_("The number of ai players (0..2)"));
  entry_ai.set_long_name("nr-ai-players");
  entry_ai.set_short_name('n');

  maingroup.add_entry(entry_ai, numberof_ai);
 
  
  Glib::OptionContext ctx;
  ctx.set_main_group(maingroup);
  
  try{
    ctx.parse(argc, argv);
  }
  catch(const Glib::OptionError& err){
    err.what();
    return 1;
  }
  
  // wer mitreden will (also die threads die mitreden wollen) muss den zeiger hier kennen!
  shareddata *data = new shareddata();

  data->setnumberai(numberof_ai);



  Gtk::Main kit(argc, argv);
  debug(_("Good Morning Dave!"));


	
	gui OurGUI(data);
	try {
	  OurGUI.init();
	}
	catch (Glib::Error) {
	  warn(_("Error when init GUI - dying"));
	  return 1;
	}

	if(OurGUI.myWindow) {
		kit.run(*(OurGUI.myWindow));
	}
	else
		warn(_("No Window created - something very strange has happened!"));
	
	delete data;
	
	return 0;
}
