// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef BOARD_H_
#define BOARD_H_
#include <stack>
#include "ourmove.hpp"
#include "field.hpp"
#include <vector>
using namespace std;




class board
{
public:
	board();
	virtual ~board();
	
	/** Checks if a move is legal.
	* @param move to be checked
	*/
	move_signal check_move(ourmove_t train, bool player);
	
	bool out_of_bounds(int pos, int step);
	bool in_temp(int field);
	
	/** Checks if there are moves that have to be done
	 */
	bool is_there_a_forced_move (int field, int player=0);
	/** Makes the move
	* @param move to be made
	*/
	//FIXMEmoh: a train is the vehicle movin' on rails - it's a joke, is it?
	move_signal move (ourmove_t train, bool player);
	  
	/** Offers the possibility to go back to an previous situation in the game
	* @param Gets the move that is to be resigned.
	*/
	//FIXMEmoh: 
	ourmove_t goback (ourmove_t train);
	    
	 /** getboard offers the possibility to get a copy of all fields
	 */
	 fieldvec_t getBoard ();
	 
	 /** Gets 25 fields and install's them in it's own field-array
	 */
	 void setBoard(fieldvec_t foo);

	/** This methode checks if there are still moves the player in charge can perform
	* if not, the game is won for the  player who made the last move. */
	bool victory(bool player);
	
	/** Clears the Board
	*/
	void clear();
	/** returns a field and its content
	* @param the number of the field to be returned
	*/
	field_t getField(int nr);
	
	/**returns the correspondind field from the board
	*	or if it exists the one from tMove
	*/
	field_t getEField(int nr);
	
private:
	field_t game[25];

	/** These fields form the next move - if it is allowed
	*/
	fieldvec_t tMove;
};

#endif /*BOARD_H_*/

