// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "gui_board.hpp"

#include <iostream>
#include <math.h>
#include "helper.h"
#include <stack>


gui_board::gui_board()   {
	board_layer=0; stone_layer=0; bg_pb=0;
	highl_layer=0; boardbg_layer=0; bg_bg_pb=0;
	WaitForPlayer=1;
	Re.requested=false;
	Re.sig=WRONG;
	stone_layer=0;
	int i=0;
	for(;i<22;i++) {
		fields[i].canvas=0;
		fields[i].nrStones=0;
		stones[i].pixb=0;
		stones[i].Officer=false;
	}
	for(;i<25;i++) {
		fields[i].canvas=0;
		hlcircles[i]=0;
		fields[i].nrStones=0;
	}
}

void gui_board::init(Gnome::Canvas::Group* new_canvas_layer, Gtk::Statusbar* new_status, Gtk::ToolButton* new_back_button, Gtk::ImageMenuItem* new_menu_back,Gtk::ImageMenuItem* new_save_as,Gtk::ImageMenuItem* new_save, shareddata* newData)
{
	data=newData;
	status=new_status;

	back_button=new_back_button;
	menu_back=new_menu_back;
	save=new_save;
	save_as=new_save_as;

	bg_layer = new Gnome::Canvas::Group(*new_canvas_layer);
	bg_layer->move(0,-80);

	boardbg_layer = new Gnome::Canvas::Group(*new_canvas_layer);
	highl_layer = new Gnome::Canvas::Group(*new_canvas_layer);
	board_layer = new Gnome::Canvas::Group(*new_canvas_layer);
	stone_layer = new Gnome::Canvas::Group(*new_canvas_layer);
	if(!stone_layer || !board_layer || !highl_layer || !boardbg_layer) {
		die("Not enough memory");
		my_signal_asc_kill.emit(1);
	}
	bg_bg = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/board_bg.png");
	bg = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/board.png");
	yabg = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/bg.png");

	bg_yabg_pb = new Gnome::Canvas::Pixbuf(*bg_layer);
	bg_bg_pb = new Gnome::Canvas::Pixbuf(*boardbg_layer);
	bg_pb=new Gnome::Canvas::Pixbuf(*board_layer);


	if(!bg_pb || !bg_bg_pb || !bg_yabg_pb) {
		die("Not enough memory");
		my_signal_asc_kill.emit(1);	
	}

	bg_yabg_pb->property_pixbuf() = yabg;
	bg_bg_pb->property_pixbuf() = bg_bg;
	bg_pb->property_pixbuf() = bg;
	

	StoneWhite = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/player1.png");
	StoneBlack = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/player2.png");
	StoneWhiteHl = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/player1hl.png");
	StoneBlackHl = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/player2hl.png");
	HighlField = Gdk::Pixbuf::create_from_file(ASCAL_PIXMAPS_DIR"/pixmaps/highlField.png");


	if(!StoneWhite || !StoneBlack || !HighlField || !StoneWhiteHl || !StoneBlackHl) {
		die("Can't find my pixmaps - Check your installation!");
		my_signal_asc_kill.emit(1);
	}

	Player1Text = new Gnome::Canvas::Text(*stone_layer,120,30,_("Player 1"));
	Player2Text = new Gnome::Canvas::Text(*stone_layer,650,30,_("Player 2"));
	if(!Player1Text || !Player2Text) {
		die("Not enough memory");
		my_signal_asc_kill.emit(1);		
	}
	Player1Text->property_fill_color_rgba() = COLOR_NEUTRAL;
	Player1Text->property_size_points() = 20;
	Player1Text->property_justification() = Gtk::JUSTIFY_LEFT;
	Player2Text->property_fill_color_rgba() = COLOR_NEUTRAL;
	Player2Text->property_size_points() = 20;
	Player2Text->property_justification() = Gtk::JUSTIFY_RIGHT;

	int i=0,k=0;
	for(;i<25;i++) {
		fields[i].canvas=new Gnome::Canvas::Group(*stone_layer);
		if(!fields[i].canvas) {
			die("Not enough memory");
			my_signal_asc_kill.emit(1);		
		}

		ko_t newKo=find_circle(i);
		newKo.x-=StoneWhite->get_width()/2;
		newKo.y-=StoneWhite->get_height()/2+5;

		fields[i].canvas->move(newKo.x,newKo.y);
//		clear_field(i);
	}

	
	for(i=0;i<11;i++) {
		stones[i].pixb = new Gnome::Canvas::Pixbuf(*fields[i].canvas);
		if(!stones[i].pixb) {
			die("Not enough memory");
			my_signal_asc_kill.emit(1);		
		}
		stones[i].pixb->property_pixbuf() = StoneWhite;
		fields[i].nrStones=1;
		for(k=0;k<22;k++)
			fields[i].Stones[k]=false;
		fields[i].Stones[i]=true; //each stone in stones[] has a unique bit in this set!!
		stones[i].pos=0;
	}
	fields[11].canvas->move(0,GUI_STONE_HEIGHT);
			for(k=0;k<22;k++)
			fields[11].Stones[k]=false;
	fields[12].canvas->move(0,GUI_STONE_HEIGHT);
			for(k=0;k<22;k++)
			fields[12].Stones[k]=false;
	fields[13].canvas->move(0,GUI_STONE_HEIGHT);
			for(k=0;k<22;k++)
			fields[13].Stones[k]=false;
	for(;i<22;i++) {
		stones[i].pixb = new Gnome::Canvas::Pixbuf(*fields[i+3].canvas);
		if(!stones[i].pixb) {
			die("Not enough memory");
			my_signal_asc_kill.emit(1);		
		}
		stones[i].pixb->property_pixbuf() = StoneBlack;
		fields[i+3].nrStones=1;
		for(k=0;k<22;k++)
			fields[i+3].Stones[k]=false;
		fields[i+3].Stones[i]=true;
		stones[i].pos=0;
	}
	for(i=0;i<25;i++) {
		hlcircles[i] = new Gnome::Canvas::Pixbuf(*highl_layer);
		if(!hlcircles[i]) {
			die("Not enough memory");
			my_signal_asc_kill.emit(1);		
		}
		hlcircles[i]->hide();
		hlcircles[i]->property_pixbuf() = HighlField;
		ko_t newKo=find_circle(i);
		newKo.x-=HighlField->get_width()/2;
		newKo.y-=HighlField->get_height()/2;
		hlcircles[i]->move(newKo.x,newKo.y);
	}

}

gui_board::~gui_board()
{
	int i=0;
	for(;i<22;i++) {
		if(fields[i].canvas)
			delete fields[i].canvas;
		if(stones[i].pixb)
			delete stones[i].pixb;
	}
	for(;i<25;i++) {
		if(fields[i].canvas)
			delete fields[i].canvas;
		if(!hlcircles[i])
			delete hlcircles[i];
	}
	if(board_layer)
		delete board_layer;
	if(stone_layer)
		delete stone_layer;
	if(highl_layer)
		delete highl_layer;

	if(bg_pb)
		delete bg_pb;
	if(bg_bg_pb)
		delete bg_bg_pb;
	if(boardbg_layer)
		delete boardbg_layer;
}

bool gui_board::on_click(GdkEventButton* ev) {
	if(Re.requested) {
		int field=wheres_the_pointer( ev->x,  ev->y);
		if(field<0 || field > 24)
			return 0;
		
		if(!genMove.size() && !fields[field].nrStones  ) {
			return 0;
		}
			
		// Now we search the constructed move for occurences of the new field 
		// if it's there every following move is deleted and unhighlighted
		for(unsigned int i=0; i<genMove.size();i++) {
			if(genMove[i]==field) {
				ourmove_it_t tempIterator;
				for(tempIterator=genMove.end()-1; tempIterator != genMove.begin()+i-1;
					--tempIterator) {
					
					hlcircles[*tempIterator]->hide();
					genMove.erase(tempIterator);
									
				}
				return 0;
			}
		}
		//otherwise we have a new one!!

		hlcircles[field]->show();
		genMove.push_back(field);
		//handler for double clicks
		if (ev->type == (GdkEventType) Gdk::DOUBLE_BUTTON_PRESS) {
			status->pop();
		  Player1Text->property_fill_color_rgba() = COLOR_NEUTRAL;
		  Player2Text->property_fill_color_rgba() = COLOR_NEUTRAL;	

			debug("Gebe den neuen Move von Spieler "<< Re.color << " weiter");		
			data->add_move(Re,genMove);
			Re.requested=false;
			ourmove_it_t tempIterator;
			for(tempIterator=genMove.end()-1;
				tempIterator != genMove.begin()-1;
				--tempIterator ) {
				
				hlcircles[*tempIterator]->hide();
				genMove.erase(tempIterator);							
			}
		}

		return 0;
	}
	return 0;
}

int gui_board::wheres_the_pointer(gdouble x1, gdouble y1) const {

	//simple arithmetik - look into find_circle to get a feeling!
	//we have double to get real rounded values - no damn floors
	x1-=81 ;
	x1/=105;
	y1-=11+27 +21+18;
	y1/=60;
	
	int x= (int) round(x1);
	int y= (int) round(y1);

	switch(x) {
		case 0:
			if(y!=3)
				break;
			return x+3*(y-(3-x));
		case 1:
			if(y>4||y<2)
				break;
			return x+3*(y-(3-x));
		case 2:
			if(y<1 || y>5)
				break;
			return x+3*(y-(3-x));
		case 3:
			if(y>6)
				break;
			return x+3*(y-(3-x));
		case 4:
			if(y<1 || y>5)
				break;
			return	3+(x-3)*4+y*3;
		case 5:
			if(y>4||y<2)
				break;
			return	3+(x-3)*4+y*3;
		case 6:
			if(y!=3)
				break;
			return	3+(x-3)*4+y*3;	
	}
	return -1;
}


ko_t gui_board::find_circle(int field) const {
	ko_t ko; //the calculated coordinates
	
	//you should draw the board for yourself to understand this!
	/* Okay here is one... ;)	
	        03
	     02 06 10
	  01 05 09 13 17
	0 04 08 12 16 20 24
	  07 11 15 19 23
	     14 18 22
	        21 	
	*/
	
	switch(field%3) {
		case 0:
			if(field==0)
				ko.x=0;
			else if(field==24)
				ko.x=6;
			else
				ko.x=3;
			break;
		case 1:
			if(field<8)
				ko.x=1;
			else
				ko.x=4;
			break;
		case 2:
			if(field<15)
				ko.x=2;
			else
				ko.x=5;
	}
	switch(field%4) {
		case 0:
			ko.y=3;
			break;
		case 1:
			if(field<20)
				ko.y=2;
			else
				ko.y=6;
			break;
		case 2:
			if(field<11)
				ko.y=1;
			else
				ko.y=5;
			break;
		case 3:
			if(field<4)
				ko.y=0;
			else
				ko.y=4;
	}
	ko.x=76+(ko.x*106.5); //hand measured offset + circle distance
	ko.y=17+27.5+60.5*(ko.y);	
	
	return ko;
}

gui_board::type_signal_asc_kill gui_board::signal_asc_kill() {
	return my_signal_asc_kill;
}

bool gui_board::check_for_news() {


    if(!data->no_moves_to_display()){
    	debug("Neue Updates sind verfuegbar");
		on_update(data->rem_move_to_display());
    }
	request_t req=data->check_moves();
    if(req.requested){
    	if(Re.requested && req.sig == RESET) {
    		on_request_move(RESET);
    	}
    	else if(!Re.requested && req.sig != RESET) {
			on_request_move(req);
		}
			     
    }
    if(!data->history_empty()){
    	back_button->set_sensitive(true);
    	menu_back->set_sensitive(true);
    	save->set_sensitive(true);
    	save_as->set_sensitive(true);
    }
    else{
    	back_button->set_sensitive(false);
    	menu_back->set_sensitive(false);
    	save_as->set_sensitive(false);
    	save->set_sensitive(false);
    }
  return true;
}


void gui_board::on_update(fieldvec_t changedFields) {
	debug("Got the following fields:")
	#ifdef DEBUG
	for(int k=0;k<(int)changedFields.size();k++) {
		debug(changedFields[k].number << ": AnzO" << changedFields[k].anz_oben << " OffO "<< changedFields[k].off_oben << " AnzU " <<changedFields[k].anz_unten << " OffU " << changedFields[k].off_unten);
	}
	#endif
	
	if(changedFields.size()==1 && changedFields[0].off_oben==-1 ) {
		//check whether one of the players won
		Re.requested=0;
		victory( (bool) (changedFields[0].off_unten));
		return;
	}

	std::stack<int> whiteOnes;
	std::stack<int> blackOnes;
	std::stack<int> whiteOfficers;
	std::stack<int> blackOfficers;
	int i=0,j;
	debug("Nach update init");
	
	
	/* Put all the stones on the changed fields on stacks to have an overview about them
	*/
	for(;i<(int)changedFields.size();i++) {
		hlcircles[changedFields[i].number]->show();
		hlcircles_alpha.push_front(changedFields[i].number);
		for(j=0;j<11;j++) {
			//the first eleven are white, the following black
			if( fields[changedFields[i].number].Stones[j] ) {
				if(stones[j].Officer) {  
					 //debug("This one is a white officer: "<<j);
					 whiteOfficers.push(j);
				}
				else {
					//debug("This one is a white man: "<<j);
					whiteOnes.push(j);
				}
			}
		}
		for(;j<22;j++) {
			if(fields[changedFields[i].number].Stones[j] ) {
				if(stones[j].Officer) {  
					//debug("This one is a black officer: "<<j);
					blackOfficers.push(j);
				}
				else {
					//debug("This one is a black man: "<<j);
					blackOnes.push(j);
				}
			}
		}
		clear_field(changedFields[i].number);
	}

	
	/* Now we will go through all the changed fields and look on all the stones there
	*/
	debug("After collecting: White: " << whiteOnes.size() << " " << whiteOfficers.size() << " Black: " << blackOnes.size() << " " << blackOfficers.size());
	for(i=0;i<(int)changedFields.size();i++) {
		if(changedFields[i].anz_oben==0) {
			//perhaps the field is empty - don't do anything! 
			//debug("Feld leer");
		}
		else if(changedFields[i].anz_oben>0) {
			//white is on top
			//debug("This is a white dominated tower");
			for(j=0;j<abs(changedFields[i].anz_oben);j++) { 
			//we look at all! players
				 //debug("Betrachte den naechsten Stein"); 				 
				 //is it an officer - let's look into the bitset
				 if(changedFields[i].off_oben & (1<<j)) {
				 	//debug("Wir haben einen Officer");
				 	//yes it is - do we have enough free officers?
				 	if(whiteOfficers.empty()) {
				 		//debug("Offiziere alle");
				 		//no, we have to upgrade one of our normal soldiers!
				 		if(whiteOnes.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		upgrade(whiteOnes.top());
				 		add_to_field(whiteOnes.top(),changedFields[i].number);
				 		whiteOnes.pop();
				 	}
				 	else {
				 		//debug("Genug Offiziere");
				 		//this is simple - we just have to move the stone
					 	add_to_field(whiteOfficers.top(),changedFields[i].number);
					 	whiteOfficers.pop();
					 }
				 }
				 else {
				 	//debug("Wir haben einen Normalo");
				 	if(whiteOnes.empty()) {
				 		//debug("Normalos alles");
				 		if(whiteOfficers.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		downgrade(whiteOfficers.top());
				 		add_to_field(whiteOfficers.top(),changedFields[i].number);
				 		whiteOfficers.pop();
				 	}
				 	else {
				 		//debug("Gnug Normalos");
					 	add_to_field(whiteOnes.top(),changedFields[i].number);
					 	whiteOnes.pop();
					 }
				 }
			 }
			 for(j=0;j<abs(changedFields[i].anz_unten);j++) {
			 	//debug("nun unten die schwarzen");
				 if(changedFields[i].off_unten & (1<<j)) {
					//debug("ein officer");
				 	if(blackOfficers.empty()) {
				 		//debug("officer alle");
				 		if(blackOnes.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		upgrade(blackOnes.top());
				 		add_to_field(blackOnes.top(),changedFields[i].number);
				 		blackOnes.pop();
				 	}
				 	else {
				 		//debug("genug officers");
					 	add_to_field(blackOfficers.top(),changedFields[i].number);
					 	blackOfficers.pop();
					 }
				 }
				 else {
				 	//debug("ein normalo");
				 	if(blackOnes.empty()) {
				 		//debug("normalos alle");
				 		if(blackOfficers.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		downgrade(blackOfficers.top());
				 		add_to_field(blackOfficers.top(),changedFields[i].number);
				 		blackOfficers.pop();
				 	}
				 	else {
				 		//debug("genug normalos");
					 	add_to_field(blackOnes.top(),changedFields[i].number);
					 	blackOnes.pop();
					 }
				 }
			 }
		}
		else {
			//black is on top
			//debug("This is a black dominated tower");
			for(j=0;j<abs(changedFields[i].anz_oben);j++) {
				//debug("Betrachte den naechsten Stein"); 
				 if(changedFields[i].off_oben & (1<<j)) {
				 	//debug("Stein ist ein Officer");
				 	if(blackOfficers.empty()) {
				 		if(blackOnes.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		upgrade(blackOnes.top());
				 		add_to_field(blackOnes.top(),changedFields[i].number);
				 		blackOnes.pop();
				 	}
				 	else {
					 	add_to_field(blackOfficers.top(),changedFields[i].number);
					 	blackOfficers.pop();
					 }
				 }
				 else {
				 	//debug("Stein ist kein Officer");
				 	if(blackOnes.empty()) {
				 		//debug("Die normalen Schwarzen sind alle");
				 		if(blackOnes.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		downgrade(blackOfficers.top());
				 		add_to_field(blackOfficers.top(),changedFields[i].number);
				 		blackOfficers.pop();
				 	}
				 	else {
				 		//debug("Wir haben genug Schwarze");
					 	add_to_field(blackOnes.top(),changedFields[i].number);
					 	blackOnes.pop();
					}
				 }
			 }
		
			for(j=0;j<abs(changedFields[i].anz_unten);j++) { 
				//debug("Betrachte den naechsten Stein"); 
				 if(changedFields[i].off_unten & (1<<j)) {
				 	if(whiteOfficers.empty()) {
				 		if(whiteOnes.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		upgrade(whiteOnes.top());
				 		add_to_field(whiteOnes.top(),changedFields[i].number);
				 		whiteOnes.pop();
				 	}
				 	else {
					 	add_to_field(whiteOfficers.top(),changedFields[i].number);
					 	whiteOfficers.pop();
					 }
				 }
				 else {
				 	if(whiteOnes.empty()) {
				 		if(whiteOfficers.empty()) {
				 			debug("ATTENTION: we shall move more players then we hade - check the board - YOU should really quit the game now");
				 			return;
				 		}
				 		downgrade(whiteOfficers.top());
				 		add_to_field(whiteOfficers.top(),changedFields[i].number);
				 		whiteOfficers.pop();
				 	}
				 	else {
					 	add_to_field(whiteOnes.top(),changedFields[i].number);
					 	whiteOnes.pop();
					 }
				 }
			 } 
		 }
	
	}
	Glib::signal_timeout().connect(sigc::mem_fun(*this, &gui_board::fade),(int)(500/changedFields.size()));
	debug("Update fertig");
}

void gui_board::add_to_field(int stone,int field) {
	//debug("Packe Stein " << stone << " auf " << field << " (Bisher: "<< fields[field].nrStones << ")");
	stones[stone].pixb->move(0,-stones[stone].pos*GUI_STONE_HEIGHT);
	fields[field].canvas->move(0, -1*GUI_STONE_HEIGHT);
	stones[stone].pixb->reparent(*fields[field].canvas);
	stones[stone].pos=fields[field].nrStones;
	stones[stone].pixb->move(0,GUI_STONE_HEIGHT * fields[field].nrStones);	
	stones[stone].pixb->lower_to_bottom();

	++(fields[field].nrStones);
	
	fields[field].Stones[stone]=1;
}

void gui_board::clear_field(int field) {
	//debug("Clearing field # " << field << " with size " << fields[field].nrStones);
	for(int i=0; i<fields[field].nrStones;i++)
		fields[field].canvas->move(0, GUI_STONE_HEIGHT);
	fields[field].nrStones=0;
	for(int i=0;i<22;i++)
		fields[field].Stones[i]=0;
	
}

void gui_board::upgrade(int stone) {
	debug("Befoerderung im Feld: " << stone);
	stones[stone].Officer=1;
	if(stone < 11) {
		stones[stone].pixb->property_pixbuf() = StoneWhiteHl;
	}
	else {
		stones[stone].pixb->property_pixbuf() = StoneBlackHl;
	}
}
void gui_board::downgrade(int stone) {
	debug("Degradierung von " << stone);
	stones[stone].Officer=0;
	if(stone < 11)
		stones[stone].pixb->property_pixbuf() = StoneWhite;
	else
		stones[stone].pixb->property_pixbuf() = StoneBlack;
}
void gui_board::on_request_move(move_signal sig) {
	if(sig==RESET) {
		status->pop();
		Player1Text->property_fill_color_rgba() = COLOR_NEUTRAL;
		Player2Text->property_fill_color_rgba() = COLOR_NEUTRAL;	
		Re.requested=false;		
	}
}

void gui_board::on_request_move(request_t re) {
	Re=re;
	Glib::ustring news;
	debug("Signal: "<<Re.sig);
	switch(Re.sig) {
		case NORMAL:
			news.append(_("It's your turn "));
			break;
		case MOVE:
			news.append(_("You have to move at least a little bit "));
			break;
		case SINGLE:
			news.append(_("You should strike "));
			break;
		
		case DOUBLE:
			news.append(_("You have to go on striking "));
			break;
			
		case WRONG_DIRECTION:
			news.append(_("You move in the wrong direction "));
			break;
		case FIELD_FULL:
			news.append(_("This field is to crowded "));		
			break;
		case WRONG_STONE:
			news.append(_("This was not your stone "));
			break;
		case CANT_BEAT:
			news.append(_("You are not allowed to strike "));
			break;
		default:
			news.append(_("This move was not allowed "));
	}
	Re.color ? news.append( Player1Text->property_text() ): news.append( Player2Text->property_text() );
	news.append(_(" - Click on a field to mark it for the next step or doubleclick to finish your move"));
	status->push(news);


	if(Re.color)
		Player1Text->property_fill_color_rgba() = COLOR_WHITE;
	else
		Player2Text->property_fill_color_rgba() = COLOR_BLACK;
}

void gui_board::back_click() {
	data->go_back(Re);
	if(data->history_empty()) {
		back_button->set_sensitive(false);
		menu_back->set_sensitive(false);
		save_as->set_sensitive(false);
		save->set_sensitive(false);
	}
}

void gui_board::clear_board() {
	debug("Clearing the board");
	Player1Text->property_fill_color_rgba() = COLOR_NEUTRAL;
	Player2Text->property_fill_color_rgba() = COLOR_NEUTRAL;	

	//clear highlighted fields
/*	ourmove_it_t tempIt;
	for(tempIt=genMove.begin();tempIt<genMove.end();++tempIt) {
		hlcircles[*tempIt]->hide();
		genMove.erase(tempIt);						
	}*/
	ourmove_it_t tempIterator;
	for(tempIterator=genMove.end()-1; tempIterator != genMove.begin()-1;
		--tempIterator) {
		
		hlcircles[*tempIterator]->hide();
		genMove.erase(tempIterator);
						
	}

	int i=0;
	for(;i<25;++i) {
		clear_field(i);
		hlcircles[i]->hide();		
	}
	hlcircles_alpha.clear();
	for(i=0;i<11;++i) {
		if(stones[i].Officer)
			downgrade(i);
		add_to_field(i,i);
	}
	for(;i<22;++i) { 
		if(stones[i].Officer)
			downgrade(i);
		add_to_field(i,i+3); 
	 }
	Re.requested=0;
	
	back_button->set_sensitive(false);
    menu_back->set_sensitive(false);
    save->set_sensitive(false);
    save_as->set_sensitive(false);
}

void gui_board::changePlayerName(bool player, Glib::ustring newName) {
	if(player)
		Player2Text->property_text() = newName;
	else
		Player1Text->property_text() = newName;
}

void gui_board::victory(bool Player) {
	if(!Player) {
		status->push(Player2Text->property_text() + _(" won the match!"));
		Player2Text->property_fill_color_rgba() = COLOR_BLACK;
		Player2Text->property_text() = Player2Text->property_text() + _(" won!");
	}
	else {
		status->push(Player1Text->property_text() + _(" won the match!"));
		Player1Text->property_fill_color_rgba() = COLOR_WHITE;
		Player1Text->property_text() = Player1Text->property_text() + _(" won!");
	}
}

bool gui_board::fade() {
	
	if(hlcircles_alpha.empty())	
		return false;
	hlcircles[hlcircles_alpha.back()]->hide();
	hlcircles_alpha.pop_back();
	
	return true;

}

