// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "guiobserver.hpp"

#include "helper.h"
#include "field.hpp"

guiobserver::guiobserver(shareddata *data, board *newLogic)
  : data (data) {
  myLogic=newLogic;
  moh_temp=0;
}

void guiobserver::update(ourmove_t move){
	status("adding move for update to queue");
	if(move.empty())
		return;
	if(move.size()==1) {
		fieldvec_t newFieldVec;
		newFieldVec.push_back(myLogic->getField(move[0]));
		data->add_move_to_display(newFieldVec);
		return;
	}
	fieldvec_t movevec;
	
	int i=1;
	for(;i<(int)move.size(); ++i) {
		movevec.push_back(myLogic->getField(move[i-1]));
		if(abs(move[i]-move[i-1])== 8 || abs(move[i]-move[i-1])== 6) {
			movevec.push_back(myLogic->getField(move[i-1]+(move[i]-move[i-1])/2));
		}
	}
	movevec.push_back(myLogic->getField(move[i-1]));
	
	debug("vor add_move_to_display")
	data->add_move_to_display(movevec);
	debug("nach add_move_to_display");
}

void guiobserver::update_all(){
	status("adding all moves for update to queue");
	fieldvec_t movevec;
	
	for(int i=0;i<25; ++i) {
		movevec.push_back(myLogic->getField(i));
	}
	
	debug("vor add_move_to_display");
	data->add_move_to_display(movevec);
	debug("nach add_move_to_display");
}

void guiobserver::victory(bool player) {
	debug("Send Victory Signal");
	field_t VicField={0,-1,0,player,0};
	fieldvec_t newFieldVec;
	newFieldVec.push_back(VicField);
	data->add_move_to_display(newFieldVec);

}
