// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <iostream>
#include "../config.h"

#define die(msg) {\
	std::cerr <<  "Error: " << __FILE__ << " " << __LINE__ << ": " << (msg) << std::endl; \
}

#ifdef DEBUG
#define debug(msg) { \
		std::cout << "Debug: " __FILE__ << " " << __LINE__ << ": " << msg << std::endl; \
		}
#else
#define	debug(msg) { }
#endif 



#define warn(msg) { \
	std::cout << "Warning: " __FILE__ << " " << __LINE__ << ": " << (msg) << std::endl; \
}

#define status(msg) { \
	debug(msg) \
}

#define _(msg)  gettext(msg) 

