// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef _HUMAN_HPP
#define _HUMAN_HPP

#include "ourplayer.hpp"
#include "ourmove.hpp"
#include "shareddata.hpp"

/** Implementation of human player.
    This class acts between the game logic and the gui.
 */

class human : public ourplayer{
public:
  /** The player needs a color and access to our shareddata.
      @param initColor The player's color can be 0 or 1
      @param data This pointer ensures access to the messages queue used for communication between both treads
   */
  human(const bool initColor, shareddata *data) 
    : ourplayer(initColor), data (data) {}
  /** Request the player to offer a move
      @param sig Indicates that the previous move was wrong
   */
  ourmove_t getourmove(move_signal sig = NORMAL);
protected:
    shareddata *data;
};

#endif
