/*
** Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _LOGIK_HPP
#define _LOGIK_HPP


#include <vector>
#include <stack>
#include "ourmove.hpp"
#include "player.hpp"
#include "ourobserver.hpp"
#include "shareddata.hpp"
#include "field.hpp"
#include "ourplayer.hpp"
#include "human.hpp"
#include "randomai.hpp"
#include "config.h"

using namespace std;

class logik {

public:
  logik(shareddata *data);
  ~logik();
  
	/** Method to start the logic thread */
	void run();
		
private:
  vector<ourobserver*> obs;

  stack<ourmove_t> history;
  shareddata *data;
  board game;
  ourplayer* players[2];
  
  Move ourmove2move(ourmove_t m) ;
  ourmove_t move2ourmove(Move m) ;
  
/*  bool tournament_player[2];
  IPv4TCPSocket* socket;
  TournamentPlayer *stdobs;
  TournamentPlayer* stdplayers[2];*/
  Position o2m[25];
  int m2o[7][7];

  void init_players();
};

#endif //_LOGIK_HPP  
