// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef _OURPLAYER_HPP
#define _OURPLAYER_HPP

#include "player.hpp"
#include "ourmove.hpp"
#include "shareddata.hpp"

/** Our general player class. 
    This class ensures that all players have our getourmove method.
 */

class ourplayer : public Player{
public:
  /** The player needs a color when it's constructed.
      @param initColor The player's color can be 0 or 1
   */
  ourplayer(const bool initColor) 
    : color (initColor) {}
  /** Creates a new move. 
      @param sig Indicates that the previous move was wrong
   */
  virtual ourmove_t getourmove(move_signal sig = NORMAL) = 0;

  /** This is there for compatibility reasons
   */
  virtual Move getMove(){
    Move empty;
    return empty;
  }

protected:
  bool color;
};

#endif
