// Copyright (C) 2006 The Ascal Authors - see AUTHORS for more information
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef _RANDOMAI_HPP
#define _RANDOMAI_HPP

#include "ourplayer.hpp"
#include "ourmove.hpp"
#include "shareddata.hpp"
#include "helper.h"

/** Simple computer player.
    This player tries all possible moves. 
    So many incorrect moves are passed to the logic which then
    has to decide whether the move is allowed or not.
 */

class randomai : public ourplayer{
public:
  /** The computer player needs a color when it's constructed.
      @param initColor The player's color can be 0 or 1
   */
  randomai(const bool initColor);
  /** Creates a new move. 
      @param sig Indicates that the previous move was wrong
   */
  ourmove_t getourmove(move_signal sig = NORMAL);
protected:
  void build_library(std::vector<ourmove_t>* library, ourmove_t* move, int size, int last=-1);
  void build_library1(std::vector<ourmove_t>* library, ourmove_t* move, int size, int last=-1);
  void print_library(std::vector<ourmove_t>* library);
  void print_move(ourmove_t* move);

  std::vector<ourmove_t> memory;
  std::vector<ourmove_t> backup;
  std::vector<ourmove_t> backup_fallback_a;
  std::vector<ourmove_t> backup_fallback_b;
  std::vector<ourmove_t> backup_fallback_c;

  bool fallback_a;
  bool fallback_b;
};

#endif
